/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (6.0.0).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package uk.co.beacon.customerservice.resources.interfaces;

import uk.co.beacon.customerservice.JsonSchema;
import uk.co.beacon.customerservice.RepresentationModelObject;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import javax.annotation.Generated;

@Generated(value = "org.openapitools.codegen.languages.SpringCodegen")
@Validated
@Tag(name = "ProfileController", description = "the ProfileController API")
public interface ProfileControllerApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    /**
     * GET /profile/locations
     *
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "descriptor111",
        tags = { "profile-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "*/*", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/alps+json", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/schema+json", schema = @Schema(implementation = String.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/profile/locations",
        produces = { "*/*", "application/alps+json", "application/schema+json" }
    )
    default ResponseEntity<String> descriptor111(
        
    ) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /profile/transportCalls
     *
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "descriptor112",
        tags = { "profile-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "*/*", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/alps+json", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/schema+json", schema = @Schema(implementation = String.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/profile/transportCalls",
        produces = { "*/*", "application/alps+json", "application/schema+json" }
    )
    default ResponseEntity<String> descriptor112(
        
    ) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /profile/transports
     *
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "descriptor113",
        tags = { "profile-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "*/*", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/alps+json", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/schema+json", schema = @Schema(implementation = String.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/profile/transports",
        produces = { "*/*", "application/alps+json", "application/schema+json" }
    )
    default ResponseEntity<String> descriptor113(
        
    ) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /profile/vehicles
     *
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "descriptor114",
        tags = { "profile-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "*/*", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/alps+json", schema = @Schema(implementation = String.class)),
                @Content(mediaType = "application/schema+json", schema = @Schema(implementation = String.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/profile/vehicles",
        produces = { "*/*", "application/alps+json", "application/schema+json" }
    )
    default ResponseEntity<String> descriptor114(
        
    ) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /profile
     *
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "listAllFormsOfMetadata1",
        tags = { "profile-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = RepresentationModelObject.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/profile",
        produces = { "application/hal+json" }
    )
    default ResponseEntity<RepresentationModelObject> listAllFormsOfMetadata1(
        
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
